<?

function action_favoris_action_dist() {
	@session_start();
	include_spip('base/abstract_sql');
	include_spip('inc/favoris_utils');
	$action = _request("favoris_action");
	$id_liste = _request("id_liste");
	$id_favori = _request("id_favori");
	$callback = _request("callback");
	$url_retour = _request("url_retour");
	$id_auteur = $GLOBALS['visiteur_session']['id_auteur'];
	switch($action){
		//when we remove a favorite from database
		case "remove_favori":
			$test = remove_favori($id_favori, $id_liste, $id_auteur);
			if($callback == "ajax"){
				if(!$test) echo _T('favoris:error_contact_admin');
				else echo 'ok';
				die();
			}
			if(!$test) $_SESSION['favoris_message'] = _T('favoris:error_contact_admin_red');
			else $_SESSION['favoris_message'] = _T('favoris:update_successful');
			header("Location: $url_retour");
			die();
			break;
			
		//when we remove a favorite with possible cookies/session mode
		case "remove_favori_cookies":
			$test = false;
			$objet = _request('objet');
			$id_objet = _request('id_objet');
			$id_liste = _request('id_liste');
			$id_favori = _request('id_favori');
			$titre = favoris_get_titre_objet($id_objet, $objet);
			
			//if visitor and visitors allowed to use favorites
			if($id_auteur == '' && favoris_allow_visitors()){
				$duree_cookies = favoris_get_meta('duree_cookies');
				$nom_cookies = favoris_get_meta('nom_cookies');
				$fav_objet = $id_liste.'__'.$objet.'__'.$id_objet;
				//if admin selected cookies
				if(favoris_allow_cookies()){
					if(setcookie($nom_cookies, str_replace($fav_objet.'--', '', $_COOKIE[$nom_cookies]), (time() + 3600*24*$duree_cookies), '/')) $test = true;
				}
				//we use a session var anyway
				unset($_SESSION[$nom_cookies][$fav_objet]);
			}
			//else if member and members allowed to use favorites, we delete from database
			elseif($id_auteur != '' && favoris_allow_members()){
				//check if we have a favorite id
				if($id_favori=='' || $id_favori==0) $id_favori = get_id_favori($id_objet, $objet, $id_auteur);
				$test = remove_favori($id_favori, $id_liste, $id_auteur);
			}
			//if ajax mode, we display the message 
			if($callback == 'ajax'){
				if(!$test) echo "error:"._T('favoris:error_contact_admin');
				else echo $titre.' '._T('favoris:successfully_removed');;
				die();
			}
			if($url_retour!='') header("Location: $url_retour");
			die();
			break;
		
		//when we add a favorite in database
		case "add_favori":
			$test = add_favori($id_favori, $id_liste, $id_auteur);
			if($callback == "ajax"){
				header("Location: spip.php?page=build_favliste&id_liste=$id_liste&lang=".$GLOBALS['lang']);
				die();
			}
			else{
				if(!$test) $_SESSION['favoris_message'] = _T('favoris:error_contact_admin_red');
				else $_SESSION['favoris_message'] = _T('favoris:update_successful');
				header("Location: ".$url_retour);
				die();
			}
			break;
			
		//when we add a favorite to one or more lists
		case "add_favori_multi":
			$objet = _request('objet');
			$id_objet = _request('id_objet');
			$id_favori=0;
			//if we send post vars to add a fav to an existing list.
			if(_request('fav_add_existing')){
				$id_listes = _request('fav_id_liste');
				if($id_auteur !='' && $id_auteur!=0){
					//create or get existing favoris
					$id_favori = create_favori($objet, $id_objet, $id_auteur);
					foreach($id_listes as $id_liste){
						//bind it to the list
						add_favori($id_favori, $id_liste, $id_auteur);
					}
				}
			}
			
			//if we send post vars to add a fav to a new list.
			elseif(_request('fav_add_new')){
				$nom_liste = _request('fav_nom');
				$acces = _request('fav_acces');
				if(trim($nom_liste)!=''){
					//if list with same name already exists for this user, we add to this list without creating a new one
					if(!$id_liste = favoris_liste_exists($nom_liste, $id_auteur))
						$id_liste = create_liste($nom_liste, $acces, $id_auteur);
					//create or get existing favoris
					$id_favori = create_favori($objet, $id_objet, $id_auteur);
					//bind it to the list
					add_favori($id_favori, $id_liste, $id_auteur);
				}
			}
			//if ajax mode, we display the message 
			if($callback == 'ajax'){
				if($id_favori==0) echo _T('favoris:error_contact_admin_red');
				else echo _T('favoris:update_successful');
				die();
			}
			//if reload mode, we set a session var for the message
			else{
				if($id_favori==0) $_SESSION['favoris_message_'.$objet.'-'.$id_objet] = _T('favoris:error_contact_admin_red');
				else $_SESSION['favoris_message_'.$objet.'-'.$id_objet] = _T('favoris:update_successful');
				header("Location: ".$url_retour);
				die();
			}
			
			break;
		
		//when we add a favorite with possible cookies/session_mode
		case 'add_favori_cookies':
			$objet = _request('objet');
			$id_objet = _request('id_objet');
			$test=false;
			$titre = favoris_get_titre_objet($id_objet, $objet);
			
			//if visitor and visitors allowed
			if($id_auteur == '' && favoris_allow_visitors()){
				$nom_cookies = favoris_get_meta('nom_cookies');
				$fav_objet = $id_liste.'__'.$objet.'__'.$id_objet;
				//if admin selected cookies
				if(favoris_allow_cookies()){
					$fav_list = $_COOKIE[$nom_cookies];
					$duree_cookies = favoris_get_meta('duree_cookies');
					if($fav_list!=''){
						//add values to cookie only if not added yet
						if(!strpos($fav_list, $fav_objet))
							$fav_list = $fav_list.$fav_objet.'--';
					}
					else $fav_list = $fav_objet.'--';
					setcookie($nom_cookies, $fav_list, (time() + (3600*24*$duree_cookies)), '/');
				}
				//we use a session var in any cases
				$_SESSION[$nom_cookies][$fav_objet] = $fav_objet;
				$test = true;
			}
			//else if member and members allowed
			elseif($id_auteur != '' && favoris_allow_members()){
				//create or get existing favoris
				$id_favori = create_favori($objet, $id_objet, $id_auteur);
				//bind it to the list
				$test = add_favori($id_favori, $id_liste, $id_auteur);
			}
			//if ajax mode, we display the message 
			if($callback == 'ajax'){
				if(!$test) echo "error:"._T('favoris:error_contact_admin');
				else echo $titre.' '._T('favoris:successfully_added');
				die();
			}
			if($url_retour!='') header("Location: $url_retour");
			die();
			break;
		
		case "move_favori":
			$id_cible = _request('id_cible');
			if(_request('cancel')!=''){
				//if cancel button pressed, we do nothing
				header("Location: ".$url_retour);
				die();
			}
			$test = add_favori($id_favori, $id_cible, $id_auteur);
			if(_request('move')!='' && $test) $test = remove_favori($id_favori, $id_liste, $id_auteur);
			if($callback == 'ajax'){
				if(_request('move')!='' && $test) echo "ok_move";
				elseif($test) echo 'ok';
				else echo _T('favoris:error_contact_admin');
				die();
			}
			if(!$test) $_SESSION['favoris_message'] = _T('favoris:error_contact_admin_red');
			else $_SESSION['favoris_message'] = _T('favoris:update_successful');
			header("Location: ".$url_retour);
			die();
			
			break;
		
		case "remove_liste":
			if(_request('cancel')!=''){
				//if cancel button pressed, we do nothing
				header("Location: ".$url_retour);
				die();
			}
			$test = remove_liste($id_liste, $id_auteur);
			if($callback == 'ajax'){
				if($test) echo "ok";
				else echo _T('favoris:error_contact_admin');
				die();
			}
			if(!$test) $_SESSION['favoris_message'] = _T('favoris:error_contact_admin_red');
			else $_SESSION['favoris_message'] = _T('favoris:update_successful');
			header("Location: ".$url_retour);
			die();
			break;
			
		case "new_liste":
			if(_request('cancel')!=''){
				//if cancel button pressed, we do nothing
				header("Location: ".$url_retour);
				die();
			}
			$nom = _request("nom_liste");
			$acces = _request("acces_liste");
			$id_liste = create_liste($nom, $acces, $id_auteur);
			if($callback == 'ajax'){
				if($id_liste>0) echo "ok_".$id_liste;
				else echo _T('favoris:error_contact_admin');
				die();
			}
			if($id_liste>0) $_SESSION['favoris_message'] = _T('favoris:update_successful');
			else $_SESSION['favoris_message'] = _T('favoris:error_contact_admin_red');
			header("Location: ".$url_retour);
			die();
			break;
			
		case "edit_liste":
			if(_request('cancel')!=''){
				//if cancel button pressed, we do nothing
				header("Location: ".$url_retour);
				die();
			}
			$nom = _request("nom_liste");
			$acces = _request("acces_liste");
			$test = edit_liste($id_liste, $id_auteur, $nom, $acces);
			if($callback == 'ajax'){
				if($test) echo "ok";
				else echo _T('favoris:error_contact_admin');
				die();
			}
			if(!$test) $_SESSION['favoris_message'] = _T('favoris:error_contact_admin_red');
			else $_SESSION['favoris_message'] = _T('favoris:update_successful');
			header("Location: ".$url_retour);
			die();
			break;
			
		case "save_positions":
			if($id_auteur!=''){
				$n_liste = 0;
				//check all request vars to find lists
				foreach($_REQUEST as $name => $positions){
					//if this is the main list, we process positions of favlists
					if($name == "favliste_main"){
						foreach($positions as $id_liste) {
							//check if favlist belongs to author
							if(favoris_auteur_possede_liste($id_auteur, $id_liste)){
								$n_liste++;
								favoris_set_position_liste($id_liste, $n_liste);
							}
						}
					}
					
					//vars called 'favori-id_favoris' are considered for favs positions
					if(substr($name, 0, 7) == "favori-"){
						$id_liste = intval(substr($name, 7));
						//check if this list exists and belongs to author or the admin, but do we really need this since we check if favorite belongs to author?
						//if(favoris_auteur_possede_liste($id_auteur, $id_liste) || favoris_auteur_possede_liste(0, $id_liste)){
							//now take care of every favorites of the list
							$n_favoris = 0;
							foreach($positions as $id_favori) {
								if(favoris_auteur_possede_favori($id_auteur, $id_favori)){
									$n_favoris++;
									favoris_set_position_favori($id_favori, $id_liste, $n_favoris);
								}
							}
						//}
					}
				}
			}
			if($callback == "ajax"){
				echo _T('favoris:update_successful');
				die();
			}
			$_SESSION['favoris_message'] = _T('favoris:update_successful');
			header("Location: $url_retour");
			die();
			break;

	}
}

?>