<?php

if (!defined("_ECRIRE_INC_VERSION")) return;

function balise_FAVORIS_ADMIN_BOUTON($p) {
    return calculer_balise_dynamique($p, 'FAVORIS_ADMIN_BOUTON', array());
}

function balise_FAVORIS_ADMIN_BOUTON_dyn($objet, $id_objet, $id_liste, $url_retour='', $suffixe='') {
	$id_auteur = $GLOBALS["visiteur_session"]["id_auteur"];
	include_spip('inc/favoris_utils');
	include_spip('base/abstract_sql');
	$nom_cookies = favoris_get_meta('nom_cookies');
	$id_favori=0;
	//if url_retour not specified in balise call, we set it with this page
	if($url_retour=='') $url_retour=self();
	
	//check if object exists
	if(!favoris_objet_exists($objet)) return;
	
	//check if the id_liste is correct
	$res = spip_query("select id_liste from spip_favlistes where id_auteur=0 and id_liste=$id_liste limit 1");
	if(sql_count($res)==1){
		//if member connected and members allowed to use favorites, we check the database
		if($id_auteur!='' && favoris_allow_members()){
			//check if fav already added
			$res = spip_query("select fav.id_favori from spip_favoris_favlistes ff, spip_favoris fav where fav.id_auteur=".sql_quote($id_auteur)." and fav.id_objet=".sql_quote($id_objet)." and fav.objet=".sql_quote($objet)." and ff.id_favori=fav.id_favori and ff.id_liste=".sql_quote($id_liste)." limit 1");
			if($row = sql_fetch($res)){ 
				$action = "remove_favori_cookies";
				$id_favori = $row['id_favori'];
			}
			else $action = "add_favori_cookies";
		}
		//if not a member we check session var if admin allows
		elseif(favoris_allow_visitors()){
			if(isset($_SESSION[$nom_cookies][$id_liste."__".$objet."__".$id_objet])) $action = "remove_favori_cookies";
			else $action = "add_favori_cookies";
		}
	}
	//if list does not exist we send an error
	else{
		return;
	}
	
	//this step is to allow more customizing
	if(file_exists(realpath(dirname(__file__)."/../formulaires/favoris_admin_bouton_".$suffixe.".html"))) $formulaire = "formulaires/favoris_admin_bouton_".$suffixe;
	else $formulaire = 'formulaires/favoris_admin_bouton';
	
	//display template
	return array($formulaire, $GLOBALS['delais'], array( 
		'objet' => $objet,
		'id_objet' => $id_objet,
		'id_liste' => $id_liste, 
		'id_favori' => $id_favori, //only if already exists
		'action' => $action, // ask to add or delete the fav (if already exists)
		'fav_url_retour' => $url_retour
	));
}
 	



?>
