<?

//////////////////
// START CONFIG //
//////////////////

//default values for configuration. There should be no need to modify these parameters, the best is to change values directly in the config page.
$GLOBALS['favoris_defaut'] = array(
	"mode_acces" => "membres", //who can use the plugin? "membres, "visiteurs" or "tous"
	"mode_visiteur" => "cookies", //way we save favorites for visitors, "cookies" or "session"
	"mode_ajax" => "oui", //do we use AJAX in forms as much as we can?
	"mode_tri" => "drop", //way we save favorites sorting, "drop" or "click"
	"duree_cookies" => "7", //lifetime of cookies in days
	"nom_cookies" => "plugin_favoris" //name of the cookie we use for this plugin
);

//function that allows admin to set the url of custom objects
function favoris_define_url_objet($objet, $id_objet){
	switch($objet){
		//example: I created an object "news", which actually doesn't exist in the table spip_urls
		/*case "news" :
			$res = spip_query("select url from spip_urls where id_objet=$id_objet and type='article'");
			$row = sql_fetch($res);
			return $row['url'];
			break;
		*/
		case "game" :
			$res = spip_query("select url from spip_urls where id_objet=".intval($id_objet)." and type='article'");
			$row = sql_fetch($res);
			return $row['url'];
			break;
		case "author" :
			$res = spip_query("select url from spip_urls where id_objet=".intval($id_objet)." and type='auteur'");
			$row = sql_fetch($res);
			return $row['url'];
			break;
		case "game_type" :
			$res = spip_query("select url from spip_urls where id_objet=".intval($id_objet)." and type='mot'");
			$row = sql_fetch($res);
			return $row['url'];
			break;
	}
	return '';
}

//function that allows admin to set the title of custom objects
function favoris_define_titre_objet($objet, $id_objet){
	switch($objet){
		//example: I created an object "news"
		/*case "news" :
			$res = spip_query("select titre from spip_articles where id_article=".invtavl($id_objet));
			$row = sql_fetch($res);
			return $row['titre'];
			break;
		*/
		/*case "game" :
			$res = spip_query("select titre from spip_articles where id_article=".intval($id_objet));
			$row = sql_fetch($res);
			return $row['titre'];
			break;*/
	}
	return '';
} 

//we define the default objects
$GLOBALS['favoris_objets']=array(
	'article' => array('spip_articles', 'id_article', 'titre'),
	'rubrique' => array('spip_rubriques', 'id_rubrique', 'titre'),
	'auteur' => array('spip_auteurs', 'id_auteur', 'login'),
	'mot' => array('spip_mots', 'id_mot', 'titre')
);

////////////////
// END CONFIG //
////////////////

include_spip('inc/favoris_utils');
@session_start();
$nom_cookies = favoris_get_meta('nom_cookies');
//if favs from cookie not copied yet, we do it
if(favoris_allow_visitors() && favoris_allow_cookies() && $_COOKIE[$nom_cookies]!='' && $_SESSION[$nom_cookies] == ''){
	//die("test");
	$fav_list = $_COOKIE[$nom_cookies];
	$fav_array = explode('--', $fav_list);
	foreach($fav_array as $fav)
		if(strpos($fav, '__')) $_SESSION[$nom_cookies][$fav]=$fav;
}

$id_auteur = $GLOBALS['visiteur_session']['id_auteur'];
//if member connected and existing session favs, we insert them in database and empty the session var
if(favoris_allow_members() && $id_auteur != '' && $_SESSION[$nom_cookies] != ''){
	
	foreach($_SESSION[$nom_cookies] as $obj => $titre){
		$objet_array = explode('__' , $obj);
		$id_liste = $objet_array[0];
		$objet = $objet_array[1];
		$id_objet = $objet_array[2];
		//first of all, the favliste must still exist
		if(mysql_num_rows(spip_query("select id_liste from spip_favlistes where id_auteur=0 and id_liste=$id_liste limit 1")) == 1){
			//then we check if fav exists
			$res = spip_query("select id_favori from spip_favoris where id_auteur=".sql_quote($id_auteur)." and objet=".sql_quote($objet)." and id_objet=".sql_quote($id_objet)." limit 1");
			if($row = sql_fetch($res)){
				$id_favori = $row['id_favori'];
				//we delete any eventual link between fav and favliste
				spip_query("delete from spip_favoris_favlistes where id_favori=".sql_quote($id_favori)." and id_liste=".sql_quote($id_liste));	
			}
			//else we create it
			else{
				spip_query("insert into spip_favoris(id_auteur, objet, id_objet) values(".sql_quote($id_auteur).", ".sql_quote($objet).", ".sql_quote($id_objet).")");
				$id_favori = mysql_insert_id();
			}
			//we add the row
			spip_query("insert into spip_favoris_favlistes(id_favori, id_liste) values(".sql_quote($id_favori).", ".sql_quote($id_liste).")");
		}
	}
	//once we saved the favs in database, we delete any session/cookie fav
	setcookie($nom_cookies);
	$_SESSION[$nom_cookies] = '';
}

function favoris_get_titre($id_favori){
	$res = spip_query("select objet, id_objet from spip_favoris where id_favori=".sql_quote($id_favori)." limit 1");
	if($row = sql_fetch($res)) return favoris_get_titre_objet($row['id_objet'], $row['objet']);
	else return $id_favori;
}

function favoris_get_titre_objet($id_objet, $objet){
	$result = favoris_define_titre_objet($objet, $id_objet);
	if($result==''){
		if(isset($GLOBALS['favoris_objets'][$objet])){
			$table = $GLOBALS['favoris_objets'][$objet][0];
			$id = $GLOBALS['favoris_objets'][$objet][1];
			$titre = $GLOBALS['favoris_objets'][$objet][2];
		}
		$res = spip_query("select ref_table, ref_id, ref_titre from spip_favoris_cfg_objets where nom=".sql_quote($objet));
		if($row = sql_fetch($res)){
			$table = $row['ref_table'];
			$id = $row['ref_id'];
			$titre = $row['ref_titre'];
		}
		$res = spip_query("select $titre from $table where $id=$id_objet limit 1");
		if($row = sql_fetch($res)) return $row[$titre];
		return $objet.' '.$id_objet;
	}
	return $result;
}

function favoris_get_url($id_favori){
	$res = spip_query("select objet, id_objet from spip_favoris where id_favori=".sql_quote($id_favori)." limit 1");
	if($row = sql_fetch($res)) return favoris_get_url_objet($row['id_objet'], $row['objet']);
	else return $id_favori;
}

function favoris_get_url_objet($id_objet, $objet){
	$result = favoris_define_url_objet($objet, $id_objet);
	if($result=='')	return generer_url_entite($id_objet, $objet);
	return $result;
}

//get a favorite id
function get_id_favori($id_objet, $objet, $id_auteur){
	$id_favori=0;
	$res = spip_query("select id_favori from spip_favoris where id_auteur=".sql_quote($id_auteur)." and objet=".sql_quote($objet)." and id_objet=".sql_quote($id_objet)." limit 1");
	if($row = sql_fetch($res)) $id_favori=$row['id_favori'];
	return $id_favori;
}


?>
